/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the SourceFieldResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SourceFieldResponseInner{}

// SourceFieldResponseInner struct for SourceFieldResponseInner
type SourceFieldResponseInner struct {
	Label *string `json:"label,omitempty"`
	Value *string `json:"value,omitempty"`
	Type  *string `json:"type,omitempty"`
}

// NewSourceFieldResponseInner instantiates a new SourceFieldResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSourceFieldResponseInner() *SourceFieldResponseInner {
	this := SourceFieldResponseInner{}
	return &this
}

// NewSourceFieldResponseInnerWithDefaults instantiates a new SourceFieldResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSourceFieldResponseInnerWithDefaults() *SourceFieldResponseInner {
	this := SourceFieldResponseInner{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *SourceFieldResponseInner) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceFieldResponseInner) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *SourceFieldResponseInner) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *SourceFieldResponseInner) SetLabel(v string) {
	o.Label = &v
}

// GetValue returns the Value field value if set, zero value otherwise.
func (o *SourceFieldResponseInner) GetValue() string {
	if o == nil || IsNil(o.Value) {
		var ret string
		return ret
	}
	return *o.Value
}

// GetValueOk returns a tuple with the Value field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceFieldResponseInner) GetValueOk() (*string, bool) {
	if o == nil || IsNil(o.Value) {
		return nil, false
	}
	return o.Value, true
}

// HasValue returns a boolean if a field has been set.
func (o *SourceFieldResponseInner) HasValue() bool {
	if o != nil && !IsNil(o.Value) {
		return true
	}

	return false
}

// SetValue gets a reference to the given string and assigns it to the Value field.
func (o *SourceFieldResponseInner) SetValue(v string) {
	o.Value = &v
}

// GetType returns the Type field value if set, zero value otherwise.
func (o *SourceFieldResponseInner) GetType() string {
	if o == nil || IsNil(o.Type) {
		var ret string
		return ret
	}
	return *o.Type
}

// GetTypeOk returns a tuple with the Type field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SourceFieldResponseInner) GetTypeOk() (*string, bool) {
	if o == nil || IsNil(o.Type) {
		return nil, false
	}
	return o.Type, true
}

// HasType returns a boolean if a field has been set.
func (o *SourceFieldResponseInner) HasType() bool {
	if o != nil && !IsNil(o.Type) {
		return true
	}

	return false
}

// SetType gets a reference to the given string and assigns it to the Type field.
func (o *SourceFieldResponseInner) SetType(v string) {
	o.Type = &v
}

func (o SourceFieldResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SourceFieldResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Value) {
		toSerialize["value"] = o.Value
	}
	if !IsNil(o.Type) {
		toSerialize["type"] = o.Type
	}
	return toSerialize, nil
}

type NullableSourceFieldResponseInner struct {
	value *SourceFieldResponseInner
	isSet bool
}

func (v NullableSourceFieldResponseInner) Get() *SourceFieldResponseInner {
	return v.value
}

func (v *NullableSourceFieldResponseInner) Set(val *SourceFieldResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableSourceFieldResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableSourceFieldResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSourceFieldResponseInner(val *SourceFieldResponseInner) *NullableSourceFieldResponseInner {
	return &NullableSourceFieldResponseInner{value: val, isSet: true}
}

func (v NullableSourceFieldResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSourceFieldResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
